﻿using System;
using System.Windows.Forms;

namespace MyscreenSaver
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {            
            if (args.Length > 0)
            {
                if (args[0].ToLower().Trim().Substring(0, 2) == "/s") // 表示
                {
                    // スクリーンセーバーを実行
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    ShowScreenSaver(); //
                    Application.Run();
                }
                else if (args[0].ToLower().Trim().Substring(0, 2) == "/p") // プレビュー
                {
                    // プレビュー画面を表示
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    //args[1] はプレビューウィンドウのハンドル
                    Application.Run(new MainForm(new IntPtr(long.Parse(args[1]))));
                }
                else if (args[0].ToLower().Trim().Substring(0, 2) == "/c") // 設定
                {
                    // スクリーンセーバーのオプション表示
                    MessageBox.Show("オプションなし"
                        + "\nこのスクリーンセーバーには、設定できるオプションはありません。",
                        "My Screen Saver",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                }
                else
                // 引数が渡されたが、それが /s, /p,/c 
                // でなかった場合
                {
                    // 常にスクリーンセーバーを表示
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    ShowScreenSaver();
                    Application.Run();
                }
            }
            else// 引数なしの場合
            {
                // 渡される引数がない場合、これはユーザーがファイルを右クリックして
                //「構成」を選んだときに発生します。通常はオプションフォームを表示します。
                // このプロジェクトでは設定フォームを準備していないため、
                // スクリーンセーバーを実行しています。
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                ShowScreenSaver(); //
                Application.Run();
            }
        }

        // スクリーンセーバーを表示
        static void ShowScreenSaver()
        {
            // コンピューター上のすべてのスクリーン(モニター)をループ
            foreach (Screen screen in Screen.AllScreens)
            {
                MainForm screensaver = new MainForm(screen.Bounds);
                screensaver.Show();
            }
        }
    }
}
